CREATE TABLE go_outside (
   todo      VARCHAR2 (100),
   on_date   DATE
)
/

BEGIN
   INSERT INTO go_outside (todo, on_date)
        VALUES ('1. Play with dog', DATE '2019-10-11');
   INSERT INTO go_outside (todo, on_date)
        VALUES ('2. Walk in the park', DATE '2019-11-10');

   COMMIT;
END;
/

CREATE OR REPLACE FUNCTION result_cache (on_date_in IN VARCHAR2)
   RETURN go_outside.todo%TYPE
   RESULT_CACHE
IS
   l_todo   go_outside.todo%TYPE;
BEGIN
   DBMS_OUTPUT.put_line ('Looking for activity on ' || 
      to_char (TO_DATE (on_date_in), 'Month DD YYYY'));

   SELECT todo
     INTO l_todo
     FROM go_outside
    WHERE on_date = TO_DATE (on_date_in);

   RETURN l_todo;
END;
/

DECLARE
   l_todo   go_outside.todo%TYPE;
BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''MM-DD-YYYY''';

   DBMS_OUTPUT.put_line ('Reset');
   l_todo := result_cache ('10-11-2019');
   l_todo := result_cache ('11-10-2019');
END;
/

/* end setup */

BEGIN
   DBMS_OUTPUT.put_line ('For two dates');
   DBMS_OUTPUT.put_line (result_cache ('10-11-2019'));
   DBMS_OUTPUT.put_line (result_cache ('11-10-2019'));
END;
/

DECLARE
   l_todo   go_outside.todo%TYPE;
BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''MM-DD-YYYY''';

   DBMS_OUTPUT.put_line ('Reset');
   l_todo := result_cache ('10-11-2019');
   l_todo := result_cache ('11-10-2019');
END;
/

BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''DD-MM-YYYY''';

   DBMS_OUTPUT.put_line ('For two dates');
   DBMS_OUTPUT.put_line (result_cache ('10-11-2019'));
   DBMS_OUTPUT.put_line (result_cache ('11-10-2019'));
END;
/

DECLARE
   l_todo   go_outside.todo%TYPE;
BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''MM-DD-YYYY''';

   DBMS_OUTPUT.put_line ('Reset');
   l_todo := result_cache ('10-11-2019');
   l_todo := result_cache ('11-10-2019');
END;
/

BEGIN
   UPDATE go_outside
      SET todo = todo || '';

   COMMIT;

   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''DD-MM-YYYY''';

   DBMS_OUTPUT.put_line ('For two dates');
   DBMS_OUTPUT.put_line (result_cache ('10-11-2019'));
   DBMS_OUTPUT.put_line (result_cache ('11-10-2019'));
END;
/

DECLARE
   l_todo   go_outside.todo%TYPE;
BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''MM-DD-YYYY''';

   DBMS_OUTPUT.put_line ('Reset');
   l_todo := result_cache ('10-11-2019');
   l_todo := result_cache ('11-10-2019');
END;
/

BEGIN
   UPDATE go_outside
      SET todo = todo || '';

   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''DD-MM-YYYY''';

   DBMS_OUTPUT.put_line ('For two dates');
   DBMS_OUTPUT.put_line (result_cache ('10-11-2019'));
   DBMS_OUTPUT.put_line (result_cache ('11-10-2019'));
END;
/

DECLARE
   l_todo   go_outside.todo%TYPE;
BEGIN
   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''MM-DD-YYYY''';

   DBMS_OUTPUT.put_line ('Reset');
   l_todo := result_cache ('10-11-2019');
   l_todo := result_cache ('11-10-2019');
END;
/

BEGIN
   UPDATE go_outside
      SET todo = todo || '';

   EXECUTE IMMEDIATE 'ALTER SESSION SET nls_date_format = ''DD-MM-YYYY''';

   DBMS_OUTPUT.put_line ('For two dates');
   DBMS_OUTPUT.put_line (result_cache ('10-11-2019'));
   DBMS_OUTPUT.put_line (result_cache ('11-10-2019'));
END;
/

DROP FUNCTION result_cache
/

DROP TABLE go_outside
/