

-- bug 23032315

DECLARE
   v1        pkg2.rec_var_1;
   j         NUMBER := 1;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   str := 'declare 
     v2 pkg2.rec_var_1; 
   j number := 1; 
   begin 
      v2.var := pkg2.var_1(10,20,30); 
      :v := v2; 
      v2.var.extend; 
      v2.var(4) := 40; 
      :v := v2; 
   end;';
   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   DBMS_SQL.close_cursor (vcursor);
   v1.var.EXTEND;
   v1.var (5) := 50;

   LOOP
      DBMS_OUTPUT.put_line (v1.var (j));
      EXIT WHEN v1.var.NEXT (j) IS NULL;
      j := v1.var.NEXT (j);
   END LOOP;
END;
/


-- bug 23032381

DECLARE
   v1        pkg3.rec_ibbi_1;
   j         NUMBER := 1;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   FOR i IN 1 .. 3
   LOOP
      v1.ibb (i) := i;
   END LOOP;

   str := 'declare 
     v2 pkg3.rec_ibbi_1; 
   j number := 1; 
begin 
   v2 := :v;       
   v2.ibb(4) := 4; 
   loop    
      dbms_output.put_line (v2.ibb(j)); 
      exit when v2.ibb.next(j) is null; 
      j := v2.ibb.next(j); 
   end loop; 
   :v := v2; 
end;';
   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   DBMS_SQL.close_cursor (vcursor);

   LOOP
      DBMS_OUTPUT.put_line (v1.ibb (j));
      EXIT WHEN v1.ibb.NEXT (j) IS NULL;
      j := v1.ibb.NEXT (j);
   END LOOP;
END;
/

-- bug 23032599

DECLARE
   v1        pkg4.rec_ibbi_2;
   j         NUMBER := 1;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   v1.ibb (1) := TRUE;
   v1.ibb (2) := FALSE;
   v1.ibb (3) := NULL;
   
   str := '
DECLARE
   v2   pkg4.rec_ibbi_2;
   j    NUMBER := 1;
BEGIN
   v2 := :v;
   v2.ibb (4) := FALSE;

   LOOP
      print_boolean (v2.ibb (j));
      EXIT WHEN v2.ibb.NEXT (j) IS NULL;
      j := v2.ibb.NEXT (j);
   END LOOP;

   :v := v2;
END;';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.close_cursor (vcursor);

   LOOP
      print_boolean (v1.ibb (j));
      EXIT WHEN v1.ibb.NEXT (j) IS NULL;
      j := v1.ibb.NEXT (j);
   END LOOP;
END;
/

DECLARE
   v1        pkg5.rec_ibvc_1;
   j         CHAR (2) := 1 || 'a';
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN

   str := q'[
DECLARE
   v2   pkg5.rec_ibvc_1;
   j    NUMBER := 1;
BEGIN
   FOR i IN 1 .. 3
   LOOP
      v2.ivc (i || 'a') := i;
   END LOOP;

   :v := v2;
   v2.ivc (4 || 'a') := 4;
   :v := v2;
END;]';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   DBMS_SQL.close_cursor (vcursor);
   v1.ivc (5 || 'a') := 5;

   LOOP
      DBMS_OUTPUT.put_line (v1.ivc (j));
      EXIT WHEN v1.ivc.NEXT (j) IS NULL;
      j := v1.ivc.NEXT (j);
   END LOOP;
END;
/

-- bug 23033005

DECLARE
   v1        tab1%ROWTYPE;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   v1.n := 10;
   v1.m := 20;
   str :=
      'declare 
     v2 tab1%rowtype; 
   begin   
      v2 := :v; 
      dbms_output.put_line (''v2.n = ''|| v2.n || '' v2.m = ''|| v2.m); 
   end;';
   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.close_cursor (vcursor);
END;
/

-- bug 23033037

DECLARE
   v1        tab1%ROWTYPE;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   str := 'declare 
     v2 tab1%rowtype; 
   begin 
      v2.n := 10; 
      v2.m := 20; 
      :v := v2;       
   end;';
   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   DBMS_SQL.close_cursor (vcursor);
   DBMS_OUTPUT.put_line ('v1.n = ' || v1.n || ' v1.m = ' || v1.m);
END;
/

-- bug 23033344

DECLARE
   v1        BOOLEAN;
   str       VARCHAR2 (5000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   str := 'declare 
     v2 boolean; 
   begin 
      v2:= true; 
      :v1 := v2; 
   end;';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable (vcursor, ':v1', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value (vcursor, ':v1', v1);
   DBMS_SQL.close_cursor (vcursor);
   print_boolean (v1);
END;
/

SHOW ERRORS

-- bug 23035569

DECLARE
   v1   dyn_sql_obj_rec := dyn_sql_obj_rec (10);
BEGIN
   DBMS_OUTPUT.put_line (v1.func_rec_out_1 ());
   DBMS_OUTPUT.put_line (v1.func_rec_out_2 ());
   DBMS_OUTPUT.put_line (v1.func_rec_inout_1 ());
   DBMS_OUTPUT.put_line (v1.func_rec_inout_2 ());
END;
/

-- bug 23035637

DECLARE
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
   v1        pkg7.rec1;
BEGIN
   str := 'declare 
     v1 pkg7.rec1; 
   str varchar2(3000); 
   vcursor integer; 
   vignore integer;     
   begin 
      str := 
        ''declare 
        v1 pkg7.rec1; 
        begin 
           v1.n := 1; 
           v1.v := ''''one''''; 
           v1.p := -1; 
           v1.b := true; 
           v1.r.p := 0; 
           v1.r.b := false; 
           :v := v1;    
        end;''; 
        vcursor := dbms_sql.open_cursor; 
        dbms_sql.parse(vcursor, str, dbms_sql.native); 
        dbms_sql.bind_variable_pkg(vcursor, '':v'',v1); 
        vignore := dbms_sql.execute(vcursor); 
        dbms_sql.variable_value_pkg(vcursor, '':v'',v1);         
        dbms_sql.close_cursor(vcursor); 
        :v := v1; 
   end;';
   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v1);
   vignore := DBMS_SQL.execute (vcursor);

   DBMS_SQL.variable_value_pkg (vcursor, ':v', v1);
   DBMS_SQL.close_cursor (vcursor);
   DBMS_OUTPUT.put_line (v1.n);
   DBMS_OUTPUT.put_line (v1.v);
   DBMS_OUTPUT.put_line (v1.p);
   print_boolean (v1.b);
   DBMS_OUTPUT.put_line (v1.r.p);
   print_boolean (v1.r.b);
END;
/

-- bug 23035946

DECLARE
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
   j         NUMBER := 1;
   v2        pkg8.rec2;
BEGIN

   str := q'[
DECLARE
   v2        pkg8.rec2;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN
   str := 'declare
        v2 pkg8.rec2;
        begin
           v2.n := pkg8.nt (true, false, null);
           v2.ib(1) := true;
           v2.ib(20) := false;
           v2.ib(30000) := null;
           v2.vr := pkg8.var (true, false, null);
           :v1 := v2;
        end;';

   EXECUTE IMMEDIATE str USING IN OUT :v;
END;]';

   EXECUTE IMMEDIATE str USING IN OUT v2;

   LOOP
      print_boolean (v2.n (j));
      EXIT WHEN v2.n.NEXT (j) IS NULL;
      j := v2.n.NEXT (j);
   END LOOP;

   j := 1;

   LOOP
      print_boolean (v2.ib (j));
      EXIT WHEN v2.ib.NEXT (j) IS NULL;
      j := v2.ib.NEXT (j);
   END LOOP;

   j := 1;

   LOOP
      print_boolean (v2.vr (j));
      EXIT WHEN v2.vr.NEXT (j) IS NULL;
      j := v2.vr.NEXT (j);
   END LOOP;
END;
/

-- bug 23039085

DECLARE
   v         pkg9.rec;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN

   str := '
DECLARE
   v   tab2%ROWTYPE;
BEGIN
   v.n := 150.45;
   :v := v;
END;';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v);
   DBMS_SQL.close_cursor (vcursor);
   DBMS_OUTPUT.put_line ('v.n = ' || v.n);
END;
/


-- bug 2309459

DECLARE
   v1        BOOLEAN;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN

   str := '
DECLARE
   v2   BOOLEAN;
BEGIN
   :v1 := v2;
END;';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable (vcursor, ':v1', v1);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.variable_value (vcursor, ':v1', v1);
   DBMS_SQL.close_cursor (vcursor);
END;
/

-- bug 23039085 : bind after execute

DECLARE
   v         pkg9.rec;
   str       VARCHAR2 (3000);
   vcursor   INTEGER;
   vignore   INTEGER;
BEGIN

   str := '
DECLARE
   v   tab2%ROWTYPE;
BEGIN
   v.n := 150.45;
   :v := v;
END;';

   vcursor := DBMS_SQL.open_cursor;
   DBMS_SQL.parse (vcursor, str, DBMS_SQL.native);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v);
   vignore := DBMS_SQL.execute (vcursor);
   DBMS_SQL.bind_variable_pkg (vcursor, ':v', v);
   DBMS_SQL.variable_value_pkg (vcursor, ':v', v);
   DBMS_SQL.close_cursor (vcursor);
   DBMS_OUTPUT.put_line ('v.n = ' || v.n);
END;
/