/* Error management with JSON data */

DECLARE
   l_fav   json_object_t;
   l_num   NUMBER;
BEGIN
   l_fav := json_object_t ('{"favorite_flavor":"chocolate"}');
   
   /* The default */
   l_fav.on_error (0);
   
   l_num := l_fav.get_number ('favorite_flavor');
   
   DBMS_OUTPUT.put_line ('Number = ' || l_num);
END;
/

DECLARE
   l_fav   json_object_t;
   l_num   NUMBER;
BEGIN
   l_fav := json_object_t ('{"favorite_flavor":"chocolate"}');
   
   /* Raise all errors */
   l_fav.on_error (1);
   
   l_num := l_fav.get_number ('favorite_flavor');
END;
/

DECLARE
   l_fav   json_object_t;
   l_eats      json_array_t;
BEGIN
   l_fav := json_object_t ('{"favorite_flavor":"chocolate"}');
   l_eats := JSON_ARRAY_T ('["Stirfry", "Yogurt", "Mosquitos"]');
   
   /* Invalid inputs */
   
   l_eats.on_error (4);
   
   /* So this will NOT raise an exception */
   DBMS_OUTPUT.PUT_LINE (l_fav.get_number ('favorite_flavor'));
   
   l_eats.put (-1, 'Ice Cream');
   
   DBMS_OUTPUT.PUT_LINE (l_eats.get_size());
END;
/