/* Grant roles to program units! */

-- CONNECT hr/hr

CREATE ROLE update_only_rl
/

GRANT UPDATE ON employees TO update_only_rl
/

CREATE OR REPLACE PACKAGE employees_mgr
   AUTHID DEFINER
IS
   PROCEDURE change_name (employee_id_in IN INTEGER);

   PROCEDURE remove_employee (employee_id_in IN INTEGER);
END;
/

CREATE OR REPLACE PACKAGE BODY employees_mgr
IS
   PROCEDURE change_name (employee_id_in IN INTEGER)
   IS
   BEGIN
      UPDATE employees
         SET last_name = UPPER (last_name)
       WHERE employee_id = employee_id_in;

      DBMS_OUTPUT.put_line ('Updated ' || SQL%ROWCOUNT || ' employees');
   END;

   PROCEDURE remove_employee (employee_id_in IN INTEGER)
   IS
   BEGIN
      DELETE FROM employees
            WHERE employee_id = employee_id_in;

      DBMS_OUTPUT.put_line ('Deleted ' || SQL%ROWCOUNT || ' employees');
   END;
END;
/

GRANT update_only_rl TO PACKAGE employees_mgr
/

begin
   employees_mgr.change_name(100);
end;
/

begin
   employees_mgr.remove_employee(100);
end;
/

rollback
/

grant execute on employees_mgr to scott
/

