CREATE OR REPLACE PROCEDURE p1
   AUTHID DEFINER
IS
   PROCEDURE nested_in_p1
   IS
   BEGIN
      RAISE PROGRAM_ERROR;
   END;
BEGIN
   nested_in_p1;
END;
/


CREATE OR REPLACE PACKAGE pkg
   AUTHID DEFINER
IS
   PROCEDURE p;
END;
/

CREATE OR REPLACE PACKAGE BODY pkg
IS
   PROCEDURE p
   IS
   BEGIN
      p1;
   END;
END;
/

CREATE OR REPLACE PROCEDURE p2
   AUTHID DEFINER
IS
BEGIN
   pkg.p;
END;
/

BEGIN
   p2;
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_backtrace);

      BEGIN
         FOR indx IN 1 .. utl_call_stack.error_depth
         LOOP
            DBMS_OUTPUT.put_line (
                  indx
               || '-'
               || utl_call_stack.backtrace_unit (indx)
               || '-'
               || TO_CHAR (utl_call_stack.backtrace_line (indx)));
         END LOOP;
      EXCEPTION
         WHEN OTHERS
         THEN
            DBMS_OUTPUT.put_line (SQLERRM);
      END;
END;
/