CREATE OR REPLACE PACKAGE qz_types
   AUTHID DEFINER
IS
   TYPE aa_t IS TABLE OF NUMBER
      INDEX BY PLS_INTEGER;

   TYPE nt_t IS TABLE OF NUMBER;
END;
/

CREATE TABLE qz_numbers (n NUMBER)
/

DECLARE
   l_dummy   DUAL.dummy%TYPE;
BEGIN
   SELECT dummy
     INTO l_dummy
     FROM DUAL
    WHERE 1 = 2;
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('*NDF*');
END;
/

DECLARE
   l_aa   qz_types.aa_t;
BEGIN
   l_aa (1) := 1;
   DBMS_OUTPUT.put_line (l_aa (2));
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('*NDF*');
END;
/

DECLARE
   l_nt   qz_types.nt_t := qz_types.nt_t (1);
BEGIN
   DBMS_OUTPUT.put_line (l_nt (2));
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('*NDF*');
END;
/

DECLARE
   l_aa   qz_types.aa_t;
BEGIN
   l_aa (1) := 1;

   FORALL indx IN 1 .. 2
      INSERT INTO qz_numbers (n)
           VALUES (l_aa (indx));
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('*NDF*');
END;
/

DECLARE
   l_nt   qz_types.aa_t;
BEGIN
   l_nt (1) := 1;

   FORALL indx IN 1 .. 2
      INSERT INTO qz_numbers (n)
           VALUES (l_nt (indx));
EXCEPTION
   WHEN NO_DATA_FOUND
   THEN
      DBMS_OUTPUT.put_line ('*NDF*');
END;
/