/* Before */

CREATE OR REPLACE PROCEDURE plch_proc (number_in IN NUMBER)
IS
   l_count   PLS_INTEGER;

   PROCEDURE plch_subproc2 (number_in IN NUMBER);

   PROCEDURE plch_subproc1 (number_in IN NUMBER DEFAULT NULL)
   IS
   BEGIN
      IF number_in = 100
      THEN
         DBMS_OUTPUT.put_line (number_in);
      ELSIF number_in <> 100
      THEN
         DBMS_OUTPUT.put_line (-1 * number_in);
      END IF;
   END;

   PROCEDURE plch_subproc2 (number_in IN NUMBER)
   IS
   BEGIN
      DBMS_OUTPUT.put_line ('Subproc2='||
         CASE
            WHEN number_in = 0 THEN 'nada'
            WHEN number_in < 0 THEN 'neg'
            WHEN number_in IS NULL THEN NULL
         END);
   END;
BEGIN
   plch_subproc1 (NULL);
   plch_subproc2 (number_in);

   BEGIN
      SELECT COUNT (*) INTO l_count FROM all_objects
       WHERE ROWNUM < 101;
   EXCEPTION
      WHEN TOO_MANY_ROWS
      THEN
         l_count := -1;
   END;

   DBMS_OUTPUT.put_line (l_count);
END;
/

and then I run the following block:

BEGIN
   plch_proc (100);
END;
/

/* after */

CREATE OR REPLACE PROCEDURE plch_proc (number_in IN NUMBER)
IS
   l_count   PLS_INTEGER;

   PROCEDURE plch_subproc2 (number_in IN NUMBER)
   IS
   BEGIN
      DBMS_OUTPUT.put_line ('Subproc2='||
         CASE
            WHEN number_in = 0 THEN 'nada'
            WHEN number_in < 0 THEN 'neg'
            WHEN number_in IS NULL THEN NULL
         END);
   END;
BEGIN
   plch_subproc2 (number_in);

   SELECT COUNT (*) INTO l_count FROM all_objects
    WHERE ROWNUM < 101;

   DBMS_OUTPUT.put_line (l_count);
END;
/

and then I run the following block:

BEGIN
   plch_proc (100);
END;
/

