CREATE OR REPLACE FUNCTION distance_between (start_lat_in    IN NUMBER,
                                             start_long_in   IN NUMBER,
                                             end_lat_in      IN NUMBER,
                                             end_long_in     IN NUMBER)
   RETURN NUMBER
IS
l_return number;
BEGIN
select case  WHEN start_lat_in = end_lat_in AND start_long_in = end_long_in
             THEN
                0
             ELSE
                  ACOS (
                         COS (radians (90 - start_lat_in))
                       * COS (radians (90 - end_lat_in))
                     +   SIN (radians (90 - start_lat_in))
                       * SIN (radians (90 - end_lat_in))
                       * COS (radians (start_long_in - end_long_in)))
                * 6371
          END into l_return from dual;/*
   RETURN CASE
             WHEN start_lat_in = end_lat_in AND start_long_in = end_long_in
             THEN
                0
             ELSE
                  ACOS (
                         COS (radians (90 - start_lat_in))
                       * COS (radians (90 - end_lat_in))
                     +   SIN (radians (90 - start_lat_in))
                       * SIN (radians (90 - end_lat_in))
                       * COS (radians (start_long_in - end_long_in)))
                * 6371
          END;*/
END;
/

begin
dbms_output.put_line (distance_between (45.45, -98.42, -48.11, -98.91));
end;
/

