/* Single bind array */

DECLARE  
   l_ids   DBMS_SQL.number_table;  
BEGIN  
   l_ids (1) := 138;  
   l_ids (2) := 147;  
  for emp_rec in (select employee_id from employees where department_id in (50, 100))
  loop DELETE FROM employees  
            WHERE employee_id = emp_rec.employee_id;end loop;
   ROLLBACK;  
END; 

DECLARE
   l_ids   DBMS_SQL.number_table;
BEGIN
   l_ids (1) := 138;
   l_ids (2) := 147;

   FORALL l_index IN 1 .. l_ids.COUNT
      DELETE FROM employees
            WHERE employee_id = l_ids (l_index);

   DBMS_OUTPUT.put_line (SQL%ROWCOUNT);
   ROLLBACK;
END;
/

/* Multiple bind arrays */

DECLARE
   l_ids      DBMS_SQL.number_table;
   l_names    DBMS_SQL.varchar2a;
   l_salaries DBMS_SQL.number_table;
BEGIN
   l_ids (1) := 138;
   l_ids (2) := 147;
   l_ids (3) := 147;
   l_names (1) := 'Sneezy';
   l_names (2) := 'Bashful';
   l_names (3) := 'Happy';
   l_salaries (1) := 1000;
   l_salaries (2) := 1500;
   l_salaries (3) := 2000;

   FORALL indx IN 1 .. l_ids.COUNT
      UPDATE employees
         SET first_name = l_names (indx), 
             salary = l_salaries (indx)
       WHERE employee_id = l_ids (indx);

   DBMS_OUTPUT.put_line (SQL%ROWCOUNT);

   ROLLBACK;
END;
/