DROP TABLE big_moments
/

CREATE TABLE big_moments
(
   what_happened   VARCHAR2 (100),
   happened_on     DATE
)
/

BEGIN    
   INSERT INTO big_moments (what_happened, happened_on)
        VALUES ('Got married', DATE '2020-01-03');

   INSERT INTO big_moments (what_happened, happened_on)
        VALUES ('First hole in one', DATE '2020-03-01');

   COMMIT;
END;
/

CREATE OR REPLACE FUNCTION what_happened (date_in IN DATE)
   RETURN VARCHAR2
   AUTHID DEFINER
   RESULT_CACHE
IS
   l_info   big_moments.what_happened%TYPE;
BEGIN
   DBMS_OUTPUT.put_line (
         'Fetching row for '
      || TO_CHAR (date_in, 'YYYY-MM-DD')
      || ' -> '
      || TO_CHAR (date_in));

   SELECT what_happened
     INTO l_info
     FROM big_moments
    WHERE happened_on = TO_DATE (TO_CHAR (date_in), 'YYYY-MM-DD');

   RETURN l_info;
END;
/

grant execute on what_happened to sfeuerstein2;

CREATE OR REPLACE PROCEDURE init (format_in IN VARCHAR2)
   AUTHID DEFINER
IS
BEGIN
   EXECUTE IMMEDIATE
      (q'[ALTER SESSION SET nls_date_format = ']' || format_in || q'[']');

   DBMS_OUTPUT.put_line ('What''s your big moment? (' || format_in || ')');
END;
/

grant execute on init to sfeuerstein2;

CREATE OR REPLACE PROCEDURE reset_cache
   AUTHID DEFINER
IS
BEGIN
   UPDATE big_moments
      SET happened_on = happened_on;

   COMMIT;
END;
/

grant execute on reset_cache to sfeuerstein2;

BEGIN
   init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
   init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
END;
/

EXEC reset_cache

BEGIN
   init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
END;
/

EXEC reset_cache

BEGIN
   init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
END;
/

EXEC reset_cache

BEGIN
   init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
   init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (what_happened (date_in => DATE '2020-01-03'));
END;
/

EXEC reset_cache

/*
BEGIN
   sfeuerstein.reset_cache; 
   --sfeuerstein.init ('YYYY-MM-DD');
   sfeuerstein.init ('DD-MM-YYYY');
   DBMS_OUTPUT.put_line (sfeuerstein.what_happened (date_in => DATE '2020-01-03'));
   DBMS_OUTPUT.put_line (sfeuerstein.what_happened (date_in => DATE '2020-01-03'));
END;
/
*/