DROP TABLE qz_big_moments
/

CREATE TABLE qz_big_moments
(
   what_happened   VARCHAR2 (100),
   happened_on     DATE
)
/

BEGIN    
   INSERT INTO qz_big_moments (what_happened, happened_on)
        VALUES ('Got married', DATE '2020-01-03');

   INSERT INTO qz_big_moments (what_happened, happened_on)
        VALUES ('First hole in one', DATE '2020-03-01');

   COMMIT;
END;
/

CREATE OR REPLACE FUNCTION qz_what_happened (date_in IN VARCHAR2)
   RETURN VARCHAR2
   AUTHID DEFINER
   RESULT_CACHE
IS
   l_info   qz_big_moments.what_happened%TYPE;
BEGIN
   DBMS_OUTPUT.put_line (
         'Fetching row for '
      || TO_DATE (date_in, 'YYYY-MM-DD')
      || ' -> '
      || TO_DATE (date_in));

   SELECT what_happened
     INTO l_info
     FROM qz_big_moments
    WHERE happened_on = TO_DATE (date_in);

   RETURN l_info;
END;
/

CREATE OR REPLACE PROCEDURE qz_init (format_in IN VARCHAR2)
   AUTHID DEFINER
IS
BEGIN
   EXECUTE IMMEDIATE
      (q'[ALTER SESSION SET nls_date_format = ']' || format_in || q'[']');

   DBMS_OUTPUT.put_line ('What''s your big moment? (' || format_in || ')');
END;
/

CREATE OR REPLACE PROCEDURE qz_reset_cache
   AUTHID DEFINER
IS
BEGIN
   UPDATE qz_big_moments
      SET happened_on = happened_on;

   COMMIT;
END;
/

BEGIN
   qz_init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => '2020-01-03'));
   qz_init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => '2020-01-03'));
END;
/

EXEC qz_reset_cache

BEGIN
   qz_init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-01-03'));
   qz_init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-03-01'));
END;
/

EXEC qz_reset_cache


BEGIN
   qz_init ('YYYY-DD-MM');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-01-03'));
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-03-01'));
END;
/

EXEC qz_reset_cache

BEGIN
   qz_init ('YYYY-MM-DD');
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-01-03'));
   DBMS_OUTPUT.put_line (qz_what_happened (date_in => DATE '2020-01-03'));
END;
/

EXEC qz_reset_cache