CREATE OR REPLACE PROCEDURE genwhen (tab_in IN VARCHAR2)
IS
   SUBTYPE identifier_t IS VARCHAR2 (100);

   v_tab   identifier_t := UPPER (tab_in);

   CURSOR cols_cur
   IS
      SELECT *
        FROM user_tab_columns
       WHERE table_name = v_tab;

   PROCEDURE pl (str IN VARCHAR2)
   IS
   BEGIN
      DBMS_OUTPUT.put_line (str);
   END;
BEGIN
   pl ('WHEN (');

   FOR rec IN cols_cur
   LOOP
      IF cols_cur%ROWCOUNT != 1
      THEN
         pl ('         OR');
      END IF;

      pl ('(   OLD.' || rec.column_name || ' != NEW.' || rec.column_name);
      pl (
            'OR (OLD.'
         || rec.column_name
         || ' IS NULL AND NEW.'
         || rec.column_name
         || ' IS NOT NULL))');
      pl (
            'OR (OLD.'
         || rec.column_name
         || ' IS NOT NULL AND NEW.'
         || rec.column_name
         || ' IS NULL))');
   END LOOP;

   pl (')');
END;
/

CREATE TABLE test_it
(
   pky   INTEGER PRIMARY KEY,
   nm    VARCHAR2 (100),
   dt    DATE
)
/

BEGIN
   genwhen (tab_in => 'TEST_IT');
END;
/