create table qz_things (
   thing_name varchar2(100),
   thing_special  varchar2(100))
/

begin
insert into qz_things (thing_name, thing_special) values 
('Bird', 'Flies through the air');
insert into qz_things (thing_name, thing_special) values 
('Earthworm', 'Breaks up soil');
insert into qz_things (thing_name, thing_special) values 
('Screen', 'Stops bugs');
commit;
end;
/

create or replace package qz_thing_mgr authid definer
is

   CURSOR thing_cur
   IS
      SELECT thing_name || ' ' || thing_special || '!' desc FROM qz_things
      order by thing_name;
type desc_nt is table of thing_cur%rowtype;
end;
/

CREATE OR REPLACE PROCEDURE qz_show_count_and_data authid definer
AS

   l_count   PLS_INTEGER;
BEGIN
   SELECT COUNT (*) INTO l_count FROM qz_things;

   dbms_output.put_line (l_count || ' Things');

   FOR rec IN qz_thing_mgr.thing_cur
   LOOP
       dbms_output.put_line(desc);
   END LOOP;
END;
/

CREATE OR REPLACE PROCEDURE load_file (location VARCHAR2, filename VARCHAR2)
AS
   l_descriptions   qz_thing_mgr.desc_nt;

   l_count   PLS_INTEGER;
BEGIN
   OPEN qz_thing_mgr.thing_cur;

   FETCH qz_thing_mgr.thing_cur BULK COLLECT INTO l_descriptions;

close qz_thing_mgr.thing_cur;

   FOR indx IN 1 .. l_descriptions.COUNT
   LOOP
      UTL_FILE.put_line (l_descriptions (indx).desc);
   END LOOP;

END;
/

/* Use COUNT OVER analytic function */

CREATE OR REPLACE PROCEDURE load_file (location VARCHAR2, filename VARCHAR2)
AS
   CURSOR c_data
   IS
      SELECT COUNT (*) OVER () row_count,
             field1 || ';' || field2 || ';' || fieldn AS line
        FROM my_table;

   l_file         UTL_FILE.file_type;

   l_first_line   BOOLEAN := TRUE;
BEGIN
   FOR thing_rec IN ( SELECT COUNT (*) OVER () row_count,thing_name || ' ' || thing_special || '!' desc FROM qz_things
      order by thing_name)
   LOOP
      IF l_first_line
      THEN
      dbms_output.put_line (l_count || ' Things');
    
         l_first_line := FALSE;
      END IF;

         dbms_output.put_line(thing_rec.desc);
   END LOOP;
END;
/