create or replace procedure full_of_dml (
   p_order  in  number,
   p_lines  in  lines_t
) 
is
   l_msg_error varchar2(1000);
   e_dml exception;
begin
   begin
      update my_orders
         set status = 2
       where order_id = p_order_id;
   exception
      when others then
         l_msg_error := 'Error changing status in my_orders';
         raise e_dml;
   end;

   for indx in 1..p_lines.count loop
      begin
         insert into my_line_items (
            order_id,
            line_num,
            line_info) 
      values (
            p_order,
            indx,
            p_lines(indx)
         );
      exception
         when others then
            l_msg_error := 'Unable to insert line for order';
            raise e_dml;
      end;
   end loop;
exception
   when e_dml 
   then
      rollback;
      raise_application_error(-20000, l_msg_error);
   when others 
   then
      rollback;
      raise_application_error
         (-20000, 'unknown error after ' || l_msg_error);
end;
/

create or replace procedure full_of_dml (
   p_order  in  number,
   p_lines  in  lines_t
) 
is
   l_scope   logger_logs.scope%type := 'full_of_dml';
   l_params  logger.tab_param;
begin
   logger.append_param(l_params, 'p_order', p_order);
   
   update my_orders
      set status = 2
    where order_id = p_order_id;

   for indx in 1..p_lines.count 
   loop
      logger.append_param (
         l_params, 'p_lines ' || indx, p_lines(indx));
      
      insert into my_line_items (
         order_id,
         line_num,
         line_info )
      values (
         p_order,
         indx,
         p_lines(indx)
      );
   end loop;
exception
   when others 
   then
      rollback;
      logger.log_error('Unhandled exception', l_scope, l_params);
      raise;
end;
/