CREATE OR REPLACE FUNCTION tst_func(p IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
  RETURN substr (p, 1, 32000);
END;
/

CREATE OR REPLACE PROCEDURE tst_proc(p IN OUT VARCHAR2) IS
BEGIN
  p := substr (p, 1, 32000);
END;
/

CREATE OR REPLACE PROCEDURE tst_proc_nocopy(p IN OUT NOCOPY VARCHAR2) IS
BEGIN
  p := substr (p, 1, 32000);
END;
/

CREATE OR REPLACE PROCEDURE run_test(string_len INTEGER, iter INTEGER) IS
  t NUMBER;
  v VARCHAR2(32767);
  PROCEDURE putResults(start_time NUMBER, unitName VARCHAR2) IS
  BEGIN
    DBMS_OUTPUT.PUT_LINE('Took: '||RPAD((DBMS_UTILITY.GET_TIME-start_time)/100,6) ||'sec. for '||unitName);
  END;
BEGIN
  v := RPAD( ' ', string_len);
  DBMS_OUTPUT.PUT_LINE('Running test with '||LENGTH(v)||' VARCHAR2 variable.');
  
  t := DBMS_UTILITY.GET_TIME;
  FOR i IN 1 .. iter LOOP
    v:= tst_func(v);
  END LOOP;
  putResults(t,'v:= tst_func(v);');
  
  t := DBMS_UTILITY.GET_TIME;
  FOR i IN 1 .. iter LOOP
    tst_proc(v);
  END LOOP;
  putResults(t,'tst_proc(v);');

  t := DBMS_UTILITY.GET_TIME;
  FOR i IN 1 .. iter LOOP
    tst_proc_nocopy(v);
  END LOOP;
  putResults(t,'tst_proc_nocopy(v);');
END;
/

DECLARE
  ITER CONSTANT INTEGER := 1000000;
BEGIN
  DBMS_OUTPUT.PUT_LINE('Running test with '||iter||' repetitive calls');
  run_test(32767, ITER);
  run_test(3277, ITER);
  run_test(327, ITER);
  run_test(32, ITER);
  run_test(3, ITER);
  run_test(1, ITER);
END;
/