/*
pipelined vs non pipelined
handle inside function
handle outside function
*/

CREATE OR REPLACE TYPE qz_integers_t IS TABLE OF VARCHAR2 (20);
/

CREATE OR REPLACE FUNCTION qz_integers
   RETURN qz_integers_t
   PIPELINED
   AUTHID DEFINER
IS
BEGIN
   PIPE ROW ('Thing1');
   PIPE ROW ('Thing2');
   PIPE ROW ('Thing3');
   RETURN;
EXCEPTION
   WHEN no_data_needed
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack);
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Cat in the Hat');
   
   FOR rec IN (SELECT COLUMN_VALUE my_string
                 FROM TABLE (qz_integers ())
                WHERE ROWNUM < 3)
   LOOP
      DBMS_OUTPUT.put_line (rec.my_string);
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack);
END;
/

CREATE OR REPLACE FUNCTION qz_integers
   RETURN qz_integers_t
   PIPELINED
   AUTHID DEFINER
IS
BEGIN
   PIPE ROW ('Thing1');
   PIPE ROW ('Thing2');
   PIPE ROW ('Thing3');
   RETURN;
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Cat in the Hat');
   FOR rec IN (SELECT COLUMN_VALUE my_string
                 FROM TABLE (qz_integers ())
                WHERE ROWNUM < 3)
   LOOP
      DBMS_OUTPUT.put_line (rec.my_string);
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack);
END;
/

CREATE OR REPLACE FUNCTION qz_integers
   RETURN qz_integers_t
   AUTHID DEFINER
IS
   l_return   
      qz_integers_t := qz_integers_t ('Thing1', 'Thing2', 'Thing3');
BEGIN
   RETURN l_return;
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Cat in the Hat');
   FOR rec IN (SELECT COLUMN_VALUE my_string
                 FROM TABLE (qz_integers ())
                WHERE ROWNUM < 3)
   LOOP
      DBMS_OUTPUT.put_line (rec.my_string);
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack);
END;
/

CREATE OR REPLACE FUNCTION qz_integers
   RETURN qz_integers_t
   PIPELINED
   AUTHID DEFINER
IS
BEGIN
   PIPE ROW ('Thing1');
   PIPE ROW ('Thing2');
   PIPE ROW ('Thing3');
   RETURN;
EXCEPTION
   WHEN no_data_needed
   THEN
      RAISE;
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Cat in the Hat');
   FOR rec IN (SELECT COLUMN_VALUE my_string
                 FROM TABLE (qz_integers ())
                WHERE ROWNUM < 3)
   LOOP
      DBMS_OUTPUT.put_line (rec.my_string);
   END LOOP;
EXCEPTION
   WHEN no_data_needed
   THEN
      DBMS_OUTPUT.put_line ('NDN '|| DBMS_UTILITY.format_error_stack);
END;
/

CREATE OR REPLACE FUNCTION qz_integers
   RETURN qz_integers_t
   PIPELINED
   AUTHID DEFINER
IS
BEGIN
   PIPE ROW ('Thing1');
   PIPE ROW ('Thing2');
   PIPE ROW ('Thing3');
   RETURN;
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Cat in the Hat');
   FOR rec IN (SELECT COLUMN_VALUE my_string
                 FROM TABLE (qz_integers ())
                WHERE ROWNUM < 3)
   LOOP
      DBMS_OUTPUT.put_line (rec.my_string);
   END LOOP;
   DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack);
END;
/