-- pipelining

create or replace type species_ot is object (
   name varchar2(100), average_size varchar2(100))
/

create or replace package brainiacs 
is
   type species_nt is table of species_ot;
   
   function big_brained_species (p_like in varchar2 default '%') 
      return species_nt
      pipelined;
end;
/

create or replace package body brainiacs 
is
   function big_brained_species (
      p_like in varchar2 default '%'
   ) return species_nt 
     pipelined
   is
   begin
         pipe row (species_ot('Human', 'Medium'));
         pipe row (species_ot('Bonobo', 'Medium'));
         pipe row (species_ot('Gorilla', 'Large'));
         pipe row (species_ot('Octopus', 'Small'));
         pipe row (species_ot('Raven', 'Very Small'));
         pipe row (species_ot('Whale', 'Very Large'));
         pipe row (species_ot('Dolphin', 'Medium'));
      return;
   end;
end;   
/

begin
   for rec in (
      select name, average_size
        from table ( brainiacs.big_brained_species() )
       order by name desc
   ) loop
      dbms_output.put_line(rec.average_size || ' ' || rec.name);
   end loop;
end;
/

-- compare performance of regular TF to pipelined