/*GO*/

DECLARE
   PROCEDURE runjob
   IS
      jobname    VARCHAR2 (100) := 'FIX_CQ_BADGES';
      run_this   VARCHAR2 (10000)
         := q'[DECLARE
   l_user_ids   DBMS_SQL.number_table;
BEGIN
   SELECT user_id
     BULK COLLECT INTO l_user_ids
     FROM (SELECT DISTINCT u.user_id
             FROM qdb_users u, qdb_quiz_results qr
            WHERE     u.user_id = qr.user_id
                  AND qr.created_on >= date '2018-01-01');

   FOR indx IN 1 .. l_user_ids.COUNT
   LOOP
      dg_gaming_mgr.check_cq_alldm_badges (l_user_ids (indx));
   END LOOP;
END;]';

      PROCEDURE remove_if_present
      IS
         job_doesnt_exist   EXCEPTION;
         PRAGMA EXCEPTION_INIT (job_doesnt_exist, -27475);
      BEGIN
         DBMS_SCHEDULER.drop_job (job_name => jobname);
      EXCEPTION
         WHEN job_doesnt_exist
         THEN
            NULL;
      END;
   BEGIN
      remove_if_present;
      
      DBMS_SCHEDULER.create_job (
         job_name          => jobname,
         job_type          => 'PLSQL_BLOCK',
         job_action        => 'BEGIN ' || run_this || ' END;',
         repeat_interval   => NULL,
         start_date        => NULL,
         enabled           => FALSE);

      DBMS_SCHEDULER.set_attribute (name        => jobname,
                                    attribute   => 'logging_level',
                                    VALUE       => DBMS_SCHEDULER.logging_full);

      DBMS_SCHEDULER.enable (jobname);
   END;
BEGIN
   runjob;
END;