DECLARE
   /* Create a constant with the list name to avoid multiple,
      hard-coded references. Notice the use of the subtype
      declared in the string_tracker package to declare the
      list name. */
   c_list_name   CONSTANT string_tracker.list_name_t := 'outcomes';
BEGIN
   /* Create the list, wiping out anything that was there before. */
   string_tracker.create_list (list_name_in        => c_list_name,
                               case_sensitive_in   => FALSE,
                               overwrite_in        => TRUE);

   string_tracker.mark_as_used (list_name_in      => c_list_name,
                                value_string_in   => 'abc');

   string_tracker.mark_as_used (list_name_in      => c_list_name,
                                value_string_in   => 'def');

   IF string_tracker.string_in_use (list_name_in      => c_list_name,
                                    value_string_in   => 'ABC')
   THEN
      DBMS_OUTPUT.put_line ('Case insenstive list - match found for ABC');
   END IF;

   IF NOT string_tracker.string_in_use (list_name_in      => c_list_name,
                                        value_string_in   => 'notinlist')
   THEN
      DBMS_OUTPUT.put_line ('No match found for notinlist');
   END IF;

   /* Now case sensitive. */
   string_tracker.create_list (list_name_in        => c_list_name,
                               case_sensitive_in   => TRUE,
                               overwrite_in        => TRUE);
   string_tracker.mark_as_used (list_name_in      => c_list_name,
                                value_string_in   => 'abc');

   IF NOT string_tracker.string_in_use (list_name_in      => c_list_name,
                                        value_string_in   => 'ABC')
   THEN
      DBMS_OUTPUT.put_line ('Case senstive list - match NOT found for ABC');
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      DBMS_OUTPUT.put_line (DBMS_UTILITY.format_error_stack ());
END;
/
