declare
   c  integer;
   m  varchar2(1000);
begin
   select sys.standard.sqlcode
     into c
     from dual;
   dbms_output.put_line('No error: ' || c);
   raise program_error;
exception
   when others then
      select sys.standard.sqlcode, sys.standard.sqlerrm into c, m
        from dual;
      dbms_output.put_line('Error code-msg via SQL sys.standard.sqlcode: '
                           || c || '-' || m);
      c  := sys.standard.sqlcode;
      m  := sys.standard.sqlerrm;
      dbms_output.put_line('Error code-msg via PLSQL sys.standard.sqlcode: '
                           || c || '-' || m);
end;
/

begin
execute immediate q'[declare
   c  integer;
   m  varchar2(1000);
begin
   select sys.standard.sqlcode
     into c
     from dual;
   dbms_output.put_line('No error: ' || c);
   raise program_error;
exception
   when others then
      select sys.standard.sqlcode, sys.standard.sqlerrm into c, m
        from dual;
      dbms_output.put_line('Error code-msg via SQL sys.standard.sqlcode: '
                           || c || '-' || m);
      c  := sys.standard.sqlcode;
      m  := sys.standard.sqlerrm;
      dbms_output.put_line('Error code-msg via PLSQL sys.standard.sqlcode: '
                           || c || '-' || m);
end;]';
end;
/
