CREATE OR REPLACE FUNCTION show_it (date_in IN DATE)
   RETURN DATE
IS
   d date;
BEGIN
   DBMS_OUTPUT.put_line ('parameter inside function ' || TO_CHAR (date_in, 'HH:MI:SS'));
   select sysdate into d from dual;
   DBMS_OUTPUT.put_line ('select sysdate inside function ' || TO_CHAR (date_in, 'HH:MI:SS'));
   
   DBMS_SESSION.sleep (1);
   RETURN date_in;
END;
/

SELECT show_it (SYSDATE)
  FROM employees
 WHERE ROWNUM < 5
/

BEGIN
   DBMS_OUTPUT.put_line ('SYSDATE called in SELECT in Loop Header');
   DBMS_OUTPUT.put_line ('start time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));

   FOR rec IN (SELECT show_it (SYSDATE) d
                 FROM employees
                WHERE ROWNUM < 5)
   LOOP
      DBMS_OUTPUT.put_line (
         'loop body returned date ' || TO_CHAR (rec.d, 'HH:MI:SS'));
      DBMS_OUTPUT.put_line (
         'loop body       sysdate ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
   END LOOP;

   DBMS_OUTPUT.put_line ('end time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
END;
/

declare
    cursor d_cur is SELECT show_it (SYSDATE) d
                 FROM employees
                WHERE ROWNUM < 5;d date;
BEGIN
   DBMS_OUTPUT.put_line ('SYSDATE called in SELECT in Loop Header');
   DBMS_OUTPUT.put_line ('start time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));

   open d_cur;
   
   LOOP fetch d_cur into d;
   exit when d_cur%NOTFOUND;
      DBMS_OUTPUT.put_line (
         'loop body returned date ' || TO_CHAR (d, 'HH:MI:SS'));
      DBMS_OUTPUT.put_line (
         'loop body       sysdate ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
   END LOOP;

   DBMS_OUTPUT.put_line ('end time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
END;
/

DECLARE
   end_date   DATE := SYSDATE + 10 / (24 * 60 * 60);
   i          INTEGER := 0;
BEGIN
   DBMS_OUTPUT.put_line ('SYSDATE called in Loop');
   DBMS_OUTPUT.put_line ('start time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));

   WHILE show_it (SYSDATE) < end_date
   LOOP
      DBMS_OUTPUT.put_line (
         'loop body sysdate ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
      EXIT WHEN i > 10;
      i := i + 1;
   END LOOP;

   DBMS_OUTPUT.put_line ('end time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('SYSDATE called in Loop Body');
   DBMS_OUTPUT.put_line ('start time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));

   FOR rec IN (SELECT date '2020-09-01' d
                 FROM employees
                WHERE ROWNUM < 5)
   LOOP
      DBMS_OUTPUT.put_line (
         'loop body returned date ' || TO_CHAR (rec.d, 'HH:MI:SS'));
      DBMS_OUTPUT.put_line (
         'loop body       sysdate ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
      DBMS_SESSION.sleep (1);
   END LOOP;

   DBMS_OUTPUT.put_line ('end time ' || TO_CHAR (SYSDATE, 'HH:MI:SS'));
END;
/