with distinct_race_cnt as (
   select count(distinct p.race_date) DISTINCT_RACE
     from races r
     join performances p
       on p.id = r.performance_Id
     join meets m
       on m.id = p.meet_id
      and m.signal_type = 'L'
      and ( r.cancel_flag <> 'Y'
       or r.cancel_flag is null )
      and p.race_date between :P46_FROM_DATE and :P46_TO_DATE
), total_race_cnt as (
   select count(distinct m.track_code || p.race_date) TOTAL_RACE
     from races r
     join performances p
       on p.id = r.performance_Id
     join meets m
       on m.id = p.meet_id
      and m.signal_type = 'L'
      and ( r.cancel_flag <> 'Y'
       or r.cancel_flag is null )
      and p.race_date between :P46_FROM_DATE and :P46_TO_DATE
), total_perf_cnt as (
   select count(distinct r.performance_id) T_PERF
     from races r
     join performances p
       on p.id = r.performance_Id
     join meets m
       on m.id = p.meet_id
      and m.signal_type = 'L'
      and ( r.cancel_flag <> 'Y'
       or r.cancel_flag is null )
      and p.race_date between :P46_FROM_DATE and :P46_TO_DATE
), cancelled_race_days as (
   select count(distinct track_code
                         || ' '
                         || race_date
                         || performance_type) CRD_COUNT
     from meets m
     join performances p
       on m.id = p.meet_id
     join races r
       on p.id = r.performance_id
    where race_date between :P46_FROM_DATE and :P46_TO_DATE
      and cancel_flag = 'Y'
), cancelled_races as (
   select sum(count(r.race_no)) CR_COUNT
     from meets m
     join performances p
       on m.id = p.meet_id
     join races r
       on r.performance_id = p.id
    where cancel_flag = 'Y'
      and race_date between :P46_FROM_DATE and :P46_TO_DATE
      and signal_type = 'L'
    group by track_code,
             p.race_date
)
select distinct_race Distinct_Race_Days,
       total_race Live_Race_Days,
       T_perf TOTAL_PERF, 
--G_PERF,H_PERF,OVERNIGHT,GALLEY,h_race Total_Horse_Race_Days,  g_race Total_GH_Race_Days,
       crd_count Cancelled_Days,
       cr_count Cancelled_Races
  from distinct_race_cnt,
       total_race_cnt,
       total_perf_cnt,
       cancelled_race_days,
       cancelled_races
--,overnight_cnt, horse_race_cnt, gh_race_cnt,  galley_cnt,horse_perf_cnt,gh_perf_cnt, 