CREATE OR REPLACE PACKAGE tmr
IS
   PROCEDURE start_timer;

   PROCEDURE show_elapsed (str IN VARCHAR2);
END tmr;
/

CREATE OR REPLACE PACKAGE BODY tmr
IS
   last_timing   NUMBER := NULL;

   PROCEDURE start_timer
   IS
   BEGIN
      last_timing := DBMS_UTILITY.get_time;
   END;

   PROCEDURE show_elapsed (str IN VARCHAR2)
   IS
   BEGIN
      DBMS_OUTPUT.put_line (
            str
         || ': '
         || MOD (DBMS_UTILITY.get_time - last_timing + POWER (2, 32),
                 POWER (2, 32)));
      start_timer;
   END;
END tmr;
/

DECLARE 
   i INTEGER := 1;
BEGIN
   trace_pkg.turn_on_trace;
   trace_pkg.g_use_shortcut := TRUE;
   tmr.start_timer;

   FOR indx IN 1 .. 10000
   LOOP
      IF trace_pkg.trace_is_on
      THEN
         i := i + 1;
      END IF;
   END LOOP;
   
   DBMS_OUTPUT.PUT_LINE (i);

   tmr.show_elapsed ('with shortcut');
   ROLLBACK;
END;
/

DECLARE 
   i INTEGER := 1;
BEGIN
   trace_pkg.turn_on_trace;
   trace_pkg.g_use_shortcut := FALSE;
   tmr.start_timer;

   FOR indx IN 1 .. 10000
   LOOP
      IF trace_pkg.trace_is_on
      THEN
         i := i + 1;
      END IF;
   END LOOP;
   
   DBMS_OUTPUT.PUT_LINE (i);
   tmr.show_elapsed ('without shortcut');
   ROLLBACK;
END;
/